=== debian/changelog ===
game-music-emu (0.6.4-1) unstable; urgency=medium

  * New upstream release
  * d/control: Bump Standards-Version from 4.6.2 to 4.7.2.
  * d/copyright: Update debian files copyright year to 2025.
  * d/rules: Update for upstream build changes.
  * d/libgme0.symbols: Update and add new symbols.
  * d/libgme-dev.install: Install libgme.a.
  * d/copyright: Fix Lintian warning, old-fsf-address-in-copyright-file.

 -- Ileana Dumitrescu <ileanadumitrescu95@gmail.com>  Wed, 29 Oct 2025 18:28:12 +0200
