=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_UBSAN=OFF

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_auto_test:
# 	Skip flaky unittests
