=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%game-music-emu-$1.tar.gz%" \
  https://github.com/libgme/game-music-emu/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
